diff --git a/web/pgadmin/browser/server_groups/servers/static/js/privilege.js b/web/pgadmin/browser/server_groups/servers/static/js/privilege.js
index e89fdbfa..49e705eb 100644
--- a/web/pgadmin/browser/server_groups/servers/static/js/privilege.js
+++ b/web/pgadmin/browser/server_groups/servers/static/js/privilege.js
@@ -1,31 +1,5 @@
-(function(root, factory) {
-  // Set up Backform appropriately for the environment. Start with AMD.
-  if (typeof define === 'function' && define.amd) {
-    define(['sources/gettext', 'underscore', 'jquery', 'backbone', 'backform', 'backgrid', 'alertify', 'pgadmin.browser.node'],
-     function(gettext, _, $, Backbone, Backform, Backgrid, Alertify, pgNode) {
-      // Export global even in AMD case in case this script is loaded with
-      // others that may still expect a global Backform.
-      return factory(root, gettext, _, $, Backbone, Backform, Backgrid, Alertify, pgNode);
-    });
-
-  // Next for Node.js or CommonJS. jQuery may not be needed as a module.
-  } else if (typeof exports !== 'undefined') {
-    var _ = require('underscore') || root._,
-      $ = root.jQuery || root.$ || root.Zepto || root.ender,
-      Backbone = require('backbone') || root.Backbone,
-      Backform = require('backform') || root.Backform;
-      Backgrid = require('backgrid') || root.Backgrid;
-      Alertify = require('alertify') || root.Alertify;
-      pgAdmin = require('pgadmin.browser.node') || root.pgAdmin.Browser.Node,
-      gettext = require('sources/gettext') || root.gettext;
-    factory(root, gettext, _, $, Backbone, Backform, Alertify, pgNode);
-
-  // Finally, as a browser global.
-  } else {
-    factory(root, root.gettext, root._, (root.jQuery || root.Zepto || root.ender || root.$), root.Backbone, root.Backform, root.Backgrid, root.alertify, root.pgAdmin.Browser.Node);
-  }
-} (this, function(root, gettext, _, $, Backbone, Backform, Backgrid, Alertify, pgNode) {
-
+define(['sources/gettext', 'underscore', 'jquery', 'backbone', 'backform', 'backgrid', 'alertify', 'pgadmin.browser.node', 'pgadmin.browser.node.ui'],
+ function(gettext, _, $, Backbone, Backform, Backgrid, Alertify, pgNode) {
   /**
    * Each Privilege, supporeted by an database object, will be represented
    * using this Model.
@@ -706,4 +680,4 @@
 
   return PrivilegeRoleModel;
 
-}));
+});
diff --git a/web/pgadmin/browser/server_groups/servers/static/js/server.js b/web/pgadmin/browser/server_groups/servers/static/js/server.js
index 0fad2f62..c57a0e24 100644
--- a/web/pgadmin/browser/server_groups/servers/static/js/server.js
+++ b/web/pgadmin/browser/server_groups/servers/static/js/server.js
@@ -3,7 +3,7 @@ define('pgadmin.node.server', [
   'underscore.string', 'pgadmin', 'pgadmin.browser', 'alertify',
   'pgadmin.server.supported_servers',
   'pgadmin.user_management.current_user',
-  'sources/alerts/alertify_wrapper',
+  'sources/alerts/alertify_wrapper', 'pgadmin.browser.server.privilege'
 ], function(
   gettext, url_for, $, _, S, pgAdmin, pgBrowser, alertify,
   supported_servers, current_user, AlertifyWrapper
@@ -1037,7 +1037,7 @@ define('pgadmin.node.server', [
       };
 
       data.is_connecting = true;
-      url = obj.generate_url(item, "connect", data, true);
+      var url = obj.generate_url(item, "connect", data, true);
       $.post(url)
       .done(function(res) {
         if (res.success == 1) {
diff --git a/web/pgadmin/browser/server_groups/servers/static/js/variable.js b/web/pgadmin/browser/server_groups/servers/static/js/variable.js
index de274263..a02ba62a 100644
--- a/web/pgadmin/browser/server_groups/servers/static/js/variable.js
+++ b/web/pgadmin/browser/server_groups/servers/static/js/variable.js
@@ -1,36 +1,8 @@
-(function(root, factory) {
-  // Set up Backform appropriately for the environment. Start with AMD.
-  if (typeof define === 'function' && define.amd) {
-    define([
-      'underscore', 'jquery', 'backbone', 'backform', 'backgrid', 'alertify',
-      'pgadmin', 'pgadmin.browser.node', 'pgadmin.browser.node.ui'
-      ],
-     function(_, $, Backbone, Backform, Backgrid, Alertify, pgAdmin, pgNode) {
-      // Export global even in AMD case in case this script is loaded with
-      // others that may still expect a global Backform.
-      return factory(root, _, $, Backbone, Backform, Alertify, pgAdmin, pgNode);
-    });
-
-  // Next for Node.js or CommonJS. jQuery may not be needed as a module.
-  } else if (typeof exports !== 'undefined') {
-    var _ = require('underscore') || root._,
-      $ = root.jQuery || root.$ || root.Zepto || root.ender,
-      Backbone = require('backbone') || root.Backbone,
-      Backform = require('backform') || root.Backform;
-      Alertify = require('alertify') || root.Alertify;
-      pgAdmin = require('pgadmin') || root.pgAdmin,
-      pgNode = require('pgadmin.browser.node') || root.pgAdmin.Browser.Node;
-
-    factory(root, _, $, Backbone, Backform, Alertify, pgAdmin, pgNode);
-
-  // Finally, as a browser global.
-  } else {
-    factory(
-        root, root._, (root.jQuery || root.Zepto || root.ender || root.$),
-        root.Backbone, root.Backform, root.pgAdmin.Browser.Node
-        );
-  }
-} (this, function(root, _, $, Backbone, Backform, Alertify, pgAdmin, pgNode) {
+define([
+  'underscore', 'jquery', 'backbone', 'backform', 'backgrid', 'alertify',
+  'pgadmin', 'pgadmin.browser.node', 'pgadmin.browser.node.ui'
+  ],
+ function(_, $, Backbone, Backform, Backgrid, Alertify, pgAdmin, pgNode) {
 
   /*
    * cellFunction for variable control.
@@ -159,7 +131,7 @@
     },
     schema: [
       {
-        id: 'name', label:'Name', type:'text', editable: true, cellHeaderClasses: 'width_percent_30',
+        id: 'name', label:'Name', type:'text', cellHeaderClasses: 'width_percent_30',
         editable: function(m) {
           return (m instanceof Backbone.Collection) ? true : m.isNew();
         },
@@ -513,8 +485,6 @@
 
         newRow.addClass("new");
         $(newRow).pgMakeVisible('backform-tab');
-      } else {
-        delete m;
       }
 
       return false;
@@ -522,4 +492,4 @@
   });
 
   return VariableModel;
-}));
+});
diff --git a/web/pgadmin/browser/server_groups/static/js/server-group.js b/web/pgadmin/browser/server_groups/static/js/server-group.js
index 2c58ea87..eb551244 100644
--- a/web/pgadmin/browser/server_groups/static/js/server-group.js
+++ b/web/pgadmin/browser/server_groups/static/js/server-group.js
@@ -1,4 +1,4 @@
-define('pgadmin.node.server-group', [
+define('pgadmin.node.server_group', [
   'sources/gettext', 'sources/url_for', 'jquery', 'underscore', 'pgadmin',
   'backbone', 'pgadmin.browser', 'pgadmin.browser.node'
 ], function(gettext, url_for, $, _, pgAdmin, Backbone) {
diff --git a/web/pgadmin/browser/static/js/datamodel.js b/web/pgadmin/browser/static/js/datamodel.js
index ad8f95f1..e47ce95b 100644
--- a/web/pgadmin/browser/static/js/datamodel.js
+++ b/web/pgadmin/browser/static/js/datamodel.js
@@ -52,8 +52,6 @@ function(_, S, pgAdmin, $, Backbone) {
                     }
                   }
                   else {
-                    if (obj)
-                      delete obj;
                     obj = null;
                   }
                   self.set(s.id, obj, {silent: true});
@@ -81,8 +79,6 @@ function(_, S, pgAdmin, $, Backbone) {
                     }
                     obj.set(val, {parse: true, silent: true});
                   } else {
-                    if (obj)
-                      delete obj;
                     obj = null;
                   }
                   res[s.id] = obj;
@@ -258,19 +254,16 @@ function(_, S, pgAdmin, $, Backbone) {
         if (opts && opts.stop)
             this.stopSession();
 
-        for(id in this.objects) {
+        for(var id in this.objects) {
           obj = this.get(id);
 
           if (obj) {
             if (obj instanceof pgBrowser.DataModel) {
               obj.reset(opts);
-              delete obj;
             } else if (obj instanceof Backbone.Model) {
               obj.clear(opts);
-              delete obj;
             } else if (obj instanceof pgBrowser.DataCollection) {
               obj.reset(opts);
-              delete obj;
             } else if (obj instanceof Backbone.Collection) {
               obj.each(function(m) {
                 if (m instanceof Backbone.DataModel) {
@@ -280,7 +273,6 @@ function(_, S, pgAdmin, $, Backbone) {
               });
               if (!(opts instanceof Array)){ opts = [opts] }
               Backbone.Collection.prototype.reset.apply(obj, opts);
-              delete obj;
             }
           }
         }
@@ -331,7 +323,7 @@ function(_, S, pgAdmin, $, Backbone) {
               self = this,
               msg;
 
-          attrChanged = function(v, k) {
+          var attrChanged = function(v, k) {
             if (k in self.objects) {
               return;
             }
@@ -520,7 +512,7 @@ function(_, S, pgAdmin, $, Backbone) {
           if (!objName) {
             var hasPrimaryKey = obj.primary_key &&
                   typeof(obj.primary_key) === 'function';
-                key = hasPrimaryKey ? obj.primary_key() : obj.cid,
+              var key = hasPrimaryKey ? obj.primary_key() : obj.cid,
                 comparator = hasPrimaryKey ?
                   function(k) {
                     var o = self.get('k');
@@ -570,7 +562,7 @@ function(_, S, pgAdmin, $, Backbone) {
           if (!objName) {
               var hasPrimaryKey = (obj.primary_key &&
                 (typeof(obj.primary_key) === 'function'));
-              key = hasPrimaryKey ? obj.primary_key() : obj.cid,
+              var key = hasPrimaryKey ? obj.primary_key() : obj.cid,
               comparator = hasPrimaryKey ?
                 function(k) {
                   var o = self.get('k');
@@ -614,7 +606,7 @@ function(_, S, pgAdmin, $, Backbone) {
               };
 
           if (obj instanceof Backbone.Collection) {
-            for (idx in obj.models) {
+            for (var idx in obj.models) {
               if (validate(obj.models[idx]))
                 break;
             }
@@ -1248,7 +1240,7 @@ function(_, S, pgAdmin, $, Backbone) {
           self.clearInvalidSessionIfModelValid(m);
         }
 
-        new_conflicting_models = self.where(condition);
+        var new_conflicting_models = self.where(condition);
         if (new_conflicting_models.length == 0) {
           self.clearInvalidSessionIfModelValid(model);
         } else if (new_conflicting_models.length == 1) {
diff --git a/web/pgadmin/browser/static/js/node.ui.js b/web/pgadmin/browser/static/js/node.ui.js
index 954aacc6..0831c1b9 100644
--- a/web/pgadmin/browser/static/js/node.ui.js
+++ b/web/pgadmin/browser/static/js/node.ui.js
@@ -1,8 +1,8 @@
 define([
-  'sources/gettext', 'jquery', 'underscore', 'pgadmin', 'backbone', 'backform', 'alertify',
-  'pgadmin.browser.node'
+  'sources/gettext', 'jquery', 'underscore', 'pgadmin', 'backbone', 'backform',
+   'alertify', 'backgrid', 'select2', 'pgadmin.browser.node'
 ],
-function(gettext, $, _, pgAdmin, Backbone, Backform, Alertify, Node) {
+function(gettext, $, _, pgAdmin, Backbone, Backform, Alertify, Backgrid) {
 
   var pgBrowser = pgAdmin.Browser;
 
@@ -169,7 +169,7 @@ function(gettext, $, _, pgAdmin, Backbone, Backform, Alertify, Node) {
         /*
          * Transform the data
          */
-        transform = this.field.get('transform') || self.defaults.transform;
+        var transform = this.field.get('transform') || self.defaults.transform;
         if (transform && _.isFunction(transform)) {
           // We will transform the data later, when rendering.
           // It will allow us to generate different data based on the
@@ -405,7 +405,7 @@ function(gettext, $, _, pgAdmin, Backbone, Backform, Alertify, Node) {
         /*
          * Transform the data
          */
-        transform = column.get('transform') || self.defaults.transform;
+        var transform = column.get('transform') || self.defaults.transform;
         if (transform && _.isFunction(transform)) {
           // We will transform the data later, when rendering.
           // It will allow us to generate different data based on the
diff --git a/web/pgadmin/browser/static/js/wizard.js b/web/pgadmin/browser/static/js/wizard.js
index 2e65c6bf..0becb2d5 100644
--- a/web/pgadmin/browser/static/js/wizard.js
+++ b/web/pgadmin/browser/static/js/wizard.js
@@ -133,7 +133,7 @@ function(_, Backbone, pgAdmin, pgBrowser) {
       this.options.disable_prev = (this.options.disable_prev ? true : this.evalASFunc(this.currPage.disable_prev));
       this.options.disable_cancel = (this.currPage.canCancel ? true : this.evalASFunc(this.currPage.disable_cancel));
 
-      that = this;
+      var that = this;
 
       /* HTML Content */
       if (data.html) { data.content = data.html; }
@@ -149,10 +149,9 @@ function(_, Backbone, pgAdmin, pgBrowser) {
       return this;
     },
     nextPage: function() {
-      this.options.curr_page.el = this.$el;
       if (!this.beforeNext()) { return false; }
 
-      page_id = this.onNext();
+      var page_id = this.onNext();
 
       if (page_id ) {
         this.currPage = this.collection.get(page_id).toJSON();
@@ -171,7 +170,7 @@ function(_, Backbone, pgAdmin, pgBrowser) {
     prevPage: function() {
       if (!this.beforePrev()) { return false; }
 
-      page_id = this.onPrev();
+      var page_id = this.onPrev();
 
       if (page_id){
         this.currPage = this.collection.get(page_id).toJSON();
@@ -264,16 +263,16 @@ function(_, Backbone, pgAdmin, pgBrowser) {
     },
     onDialogHelp: function() {
       // See if we can find an existing panel, if not, create one
-      pnlDialogHelp = pgBrowser.docker.findPanels('pnl_online_help')[0];
+      var pnlDialogHelp = pgBrowser.docker.findPanels('pnl_online_help')[0];
 
       if (pnlDialogHelp == null) {
-        pnlProperties = pgBrowser.docker.findPanels('properties')[0];
+        var pnlProperties = pgBrowser.docker.findPanels('properties')[0];
         pgBrowser.docker.addPanel('pnl_online_help', wcDocker.DOCK.STACKED, pnlProperties);
         pnlDialogHelp = pgBrowser.docker.findPanels('pnl_online_help')[0];
       }
 
       // Update the panel
-      iframe = $(pnlDialogHelp).data('embeddedFrame');
+      var iframe = $(pnlDialogHelp).data('embeddedFrame');
 
       pnlDialogHelp.focus();
       iframe.openURL(this.options.wizard_help);
diff --git a/web/pgadmin/dashboard/__init__.py b/web/pgadmin/dashboard/__init__.py
index 8f813d7c..b91ccb2a 100644
--- a/web/pgadmin/dashboard/__init__.py
+++ b/web/pgadmin/dashboard/__init__.py
@@ -62,7 +62,7 @@ class DashboardModule(PgAdminModule):
                 isPrivate=False,
                 limit=1,
                 isIframe=False,
-                canHide=True)
+                canHide=True).__dict__
         ]
 
     def register_preferences(self):
@@ -114,6 +114,41 @@ class DashboardModule(PgAdminModule):
             help_str=gettext('The number of seconds between graph samples.')
         )
 
+    def get_exposed_url_endpoints(self):
+        """
+        Returns:
+            list: a list of url endpoints exposed to the client.
+        """
+        return [
+            'dashboard.index', 'dashboard.get_by_sever_id',
+            'dashboard.get_by_database_id',
+            'dashboard.session_stats',
+            'dashboard.get_session_stats_by_sever_id',
+            'dashboard.get_session_stats_by_database_id',
+            'dashboard.tps_stats',
+            'dashboard.tps_stats_by_server_id',
+            'dashboard.tps_stats_by_database_id',
+            'dashboard.ti_stats',
+            'dashboard.ti_stats_by_server_id',
+            'dashboard.ti_stats_by_database_id',
+            'dashboard.to_stats',
+            'dashboard.to_stats_by_server_id',
+            'dashboard.to_stats_by_database_id',
+            'dashboard.bio_stats',
+            'dashboard.bio_stats_by_server_id',
+            'dashboard.bio_stats_by_database_id',
+            'dashboard.activity',
+            'dashboard.get_activity_by_server_id',
+            'dashboard.get_activity_by_database_id',
+            'dashboard.locks',
+            'dashboard.get_locks_by_server_id',
+            'dashboard.get_locks_by_database_id',
+            'dashboard.prepared',
+            'dashboard.get_prepared_by_server_id',
+            'dashboard.get_prepared_by_database_id',
+            'dashboard.config',
+            'dashboard.get_config_by_server_id',
+        ]
 
 blueprint = DashboardModule(MODULE_NAME, __name__)
 
@@ -200,9 +235,9 @@ def script():
                     mimetype="application/javascript")
 
 
-@blueprint.route('/')
-@blueprint.route('/<int:sid>')
-@blueprint.route('/<int:sid>/<int:did>')
+@blueprint.route('/', endpoint='index')
+@blueprint.route('/<int:sid>', endpoint='get_by_sever_id')
+@blueprint.route('/<int:sid>/<int:did>', endpoint='get_by_database_id')
 @login_required
 def index(sid=None, did=None):
     """
@@ -286,9 +321,13 @@ def get_data(sid, did, template):
     )
 
 
-@blueprint.route('/session_stats/')
-@blueprint.route('/session_stats/<int:sid>')
-@blueprint.route('/session_stats/<int:sid>/<int:did>')
+@blueprint.route('/session_stats/', endpoint='session_stats')
+@blueprint.route(
+    '/session_stats/<int:sid>', endpoint='get_session_stats_by_sever_id')
+@blueprint.route(
+    '/session_stats/<int:sid>/<int:did>',
+    endpoint='get_session_stats_by_database_id'
+)
 @login_required
 @check_precondition
 def session_stats(sid=None, did=None):
@@ -300,9 +339,11 @@ def session_stats(sid=None, did=None):
     return get_data(sid, did, 'session_stats.sql')
 
 
-@blueprint.route('/tps_stats/')
-@blueprint.route('/tps_stats/<int:sid>')
-@blueprint.route('/tps_stats/<int:sid>/<int:did>')
+@blueprint.route('/tps_stats/', endpoint='tps_stats')
+@blueprint.route('/tps_stats/<int:sid>', endpoint='tps_stats_by_server_id')
+@blueprint.route(
+    '/tps_stats/<int:sid>/<int:did>', endpoint='tps_stats_by_database_id'
+)
 @login_required
 @check_precondition
 def tps_stats(sid=None, did=None):
@@ -314,9 +355,10 @@ def tps_stats(sid=None, did=None):
     return get_data(sid, did, 'tps_stats.sql')
 
 
-@blueprint.route('/ti_stats/')
-@blueprint.route('/ti_stats/<int:sid>')
-@blueprint.route('/ti_stats/<int:sid>/<int:did>')
+@blueprint.route('/ti_stats/', endpoint='ti_stats')
+@blueprint.route('/ti_stats/<int:sid>', endpoint='ti_stats_by_server_id')
+@blueprint.route(
+    '/ti_stats/<int:sid>/<int:did>', endpoint='ti_stats_by_database_id')
 @login_required
 @check_precondition
 def ti_stats(sid=None, did=None):
@@ -328,9 +370,10 @@ def ti_stats(sid=None, did=None):
     return get_data(sid, did, 'ti_stats.sql')
 
 
-@blueprint.route('/to_stats/')
-@blueprint.route('/to_stats/<int:sid>')
-@blueprint.route('/to_stats/<int:sid>/<int:did>')
+@blueprint.route('/to_stats/', endpoint='to_stats')
+@blueprint.route('/to_stats/<int:sid>', endpoint='to_stats_by_server_id')
+@blueprint.route(
+    '/to_stats/<int:sid>/<int:did>', endpoint='to_stats_by_database_id')
 @login_required
 @check_precondition
 def to_stats(sid=None, did=None):
@@ -342,9 +385,10 @@ def to_stats(sid=None, did=None):
     return get_data(sid, did, 'to_stats.sql')
 
 
-@blueprint.route('/bio_stats/')
-@blueprint.route('/bio_stats/<int:sid>')
-@blueprint.route('/bio_stats/<int:sid>/<int:did>')
+@blueprint.route('/bio_stats/', endpoint='bio_stats')
+@blueprint.route('/bio_stats/<int:sid>', endpoint='bio_stats_by_server_id')
+@blueprint.route(
+    '/bio_stats/<int:sid>/<int:did>', endpoint='bio_stats_by_database_id')
 @login_required
 @check_precondition
 def bio_stats(sid=None, did=None):
@@ -356,9 +400,10 @@ def bio_stats(sid=None, did=None):
     return get_data(sid, did, 'bio_stats.sql')
 
 
-@blueprint.route('/activity/')
-@blueprint.route('/activity/<int:sid>')
-@blueprint.route('/activity/<int:sid>/<int:did>')
+@blueprint.route('/activity/', endpoint='activity')
+@blueprint.route('/activity/<int:sid>', endpoint='get_activity_by_server_id')
+@blueprint.route(
+    '/activity/<int:sid>/<int:did>', endpoint='get_activity_by_database_id')
 @login_required
 @check_precondition
 def activity(sid=None, did=None):
@@ -370,9 +415,10 @@ def activity(sid=None, did=None):
     return get_data(sid, did, 'activity.sql')
 
 
-@blueprint.route('/locks/')
-@blueprint.route('/locks/<int:sid>')
-@blueprint.route('/locks/<int:sid>/<int:did>')
+@blueprint.route('/locks/', endpoint='locks')
+@blueprint.route('/locks/<int:sid>', endpoint='get_locks_by_server_id')
+@blueprint.route(
+    '/locks/<int:sid>/<int:did>', endpoint='get_locks_by_database_id')
 @login_required
 @check_precondition
 def locks(sid=None, did=None):
@@ -384,9 +430,10 @@ def locks(sid=None, did=None):
     return get_data(sid, did, 'locks.sql')
 
 
-@blueprint.route('/prepared/')
-@blueprint.route('/prepared/<int:sid>')
-@blueprint.route('/prepared/<int:sid>/<int:did>')
+@blueprint.route('/prepared/', endpoint='prepared')
+@blueprint.route('/prepared/<int:sid>', endpoint='get_prepared_by_server_id')
+@blueprint.route(
+    '/prepared/<int:sid>/<int:did>', endpoint='get_prepared_by_database_id')
 @login_required
 @check_precondition
 def prepared(sid=None, did=None):
@@ -398,8 +445,8 @@ def prepared(sid=None, did=None):
     return get_data(sid, did, 'prepared.sql')
 
 
-@blueprint.route('/config/')
-@blueprint.route('/config/<int:sid>')
+@blueprint.route('/config/', endpoint='config')
+@blueprint.route('/config/<int:sid>', endpoint='get_config_by_server_id')
 @login_required
 @check_precondition
 def config(sid=None):
diff --git a/web/pgadmin/feature_tests/query_tool_tests.py b/web/pgadmin/feature_tests/query_tool_tests.py
index c0582875..56547cbd 100644
--- a/web/pgadmin/feature_tests/query_tool_tests.py
+++ b/web/pgadmin/feature_tests/query_tool_tests.py
@@ -183,6 +183,7 @@ SELECT generate_series(1, {}) as id""".format(
             config.ON_DEMAND_RECORD_COUNT * ON_DEMAND_CHUNKS)
 
         wait = WebDriverWait(self.page.driver, 10)
+        time.sleep(1)
         self.page.fill_codemirror_area_with(query)
 
         self.page.find_by_id("btn-flash").click()
@@ -194,16 +195,15 @@ SELECT generate_series(1, {}) as id""".format(
 
         # scroll to bottom to fetch next chunk of result set.
         self.driver.execute_script(
-            "$('.slick-viewport').scrollTop($('.grid-canvas').height());"
+            "pgAdmin.SqlEditor.jquery('.slick-viewport').scrollTop(pgAdmin.SqlEditor.jquery('.grid-canvas').height());"
         )
-
         # wait for ajax to complete.
         time.sleep(1)
 
         # again scroll to bottom to bring last row of next chunk in
         # viewport.
         self.driver.execute_script(
-            "$('.slick-viewport').scrollTop($('.grid-canvas').height());"
+            "pgAdmin.SqlEditor.jquery('.slick-viewport').scrollTop(pgAdmin.SqlEditor.jquery('.grid-canvas').height());"
         )
 
         row_id_to_find = config.ON_DEMAND_RECORD_COUNT * ON_DEMAND_CHUNKS
@@ -234,7 +234,7 @@ SELECT generate_series(1, {}) as id""".format(
         # scroll to bottom to bring last row of next chunk in
         # viewport.
         self.driver.execute_script(
-            "$('.slick-viewport').scrollTop($('.grid-canvas').height());"
+            "pgAdmin.SqlEditor.jquery('.slick-viewport').scrollTop(pgAdmin.SqlEditor.jquery('.grid-canvas').height());"
         )
 
         canvas = wait.until(EC.presence_of_element_located(
@@ -274,7 +274,7 @@ SELECT generate_series(1, {}) as id1, 'dummy' as id2""".format(
         # scroll to bottom to bring last row of next chunk in
         # viewport.
         self.driver.execute_script(
-            "$('.slick-viewport').scrollTop($('.grid-canvas').height());"
+            "pgAdmin.SqlEditor.jquery('.slick-viewport').scrollTop(pgAdmin.SqlEditor.jquery('.grid-canvas').height());"
         )
 
         canvas = wait.until(EC.presence_of_element_located(
diff --git a/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py b/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py
index ac50ea13..0f26917b 100644
--- a/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py
+++ b/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py
@@ -152,6 +152,7 @@ class CheckForXssFeatureTest(BaseFeatureTest):
     def _check_xss_in_query_tool(self):
         self.page.driver.find_element_by_link_text("Tools").click()
         self.page.find_by_partial_link_text("Query Tool").click()
+        self.page.click_tab('Query -')
         self.page.fill_codemirror_area_with("select '<img src=\"x\" onerror=\"console.log(1)\">'")
         time.sleep(1)
         self.page.find_by_id("btn-flash").click()
diff --git a/web/pgadmin/help/__init__.py b/web/pgadmin/help/__init__.py
index ca30303c..cab7a039 100644
--- a/web/pgadmin/help/__init__.py
+++ b/web/pgadmin/help/__init__.py
@@ -52,28 +52,28 @@ class HelpModule(PgAdminModule):
                 priority=100,
                 isPrivate=True,
                 title=gettext('Online Help'),
-                icon='fa fa-question'),
+                icon='fa fa-question').__dict__,
 
             Panel(
                 name='pnl_pgadmin_website',
                 priority=200,
                 title=gettext('pgAdmin Website'),
                 icon='fa fa-external-link',
-                content='https://www.pgadmin.org/'),
+                content='https://www.pgadmin.org/').__dict__,
 
             Panel(
                 name='pnl_postgresql_website',
                 priority=300,
                 title=gettext('PostgreSQL Website'),
                 icon='fa fa-external-link',
-                content='http://www.postgresql.org/'),
+                content='http://www.postgresql.org/').__dict__,
 
             Panel(
                 name='pnl_sql_help',
                 priority=400,
                 isPrivate=True,
                 icon='fa fa-info',
-                title=gettext('SQL Help'))]
+                title=gettext('SQL Help')).__dict__]
 
     def register_preferences(self):
         """
diff --git a/web/pgadmin/misc/__init__.py b/web/pgadmin/misc/__init__.py
index b343f613..027dfca0 100644
--- a/web/pgadmin/misc/__init__.py
+++ b/web/pgadmin/misc/__init__.py
@@ -66,7 +66,7 @@ class MiscModule(PgAdminModule):
         Returns:
             list: a list of url endpoints exposed to the client.
         """
-        return ['misc.ping']
+        return ['misc.ping', 'misc.index']
 
 
 # Initialise the module
@@ -76,7 +76,7 @@ blueprint = MiscModule(MODULE_NAME, __name__)
 ##########################################################################
 # A special URL used to "ping" the server
 ##########################################################################
-@blueprint.route("/")
+@blueprint.route("/", endpoint='index')
 def index():
     return ''
 
diff --git a/web/pgadmin/misc/bgprocess/static/js/bgprocess.js b/web/pgadmin/misc/bgprocess/static/js/bgprocess.js
index 92000a34..12271fbd 100644
--- a/web/pgadmin/misc/bgprocess/static/js/bgprocess.js
+++ b/web/pgadmin/misc/bgprocess/static/js/bgprocess.js
@@ -1,4 +1,4 @@
-define([
+define('misc.bgprocess', [
   'pgadmin', 'sources/gettext', 'sources/url_for', 'underscore',
   'underscore.string', 'jquery', 'pgadmin.browser', 'alertify',
   'pgadmin.browser.messages'
@@ -135,12 +135,14 @@ define([
           !self.details && !_.isNull(self.exit_code)
         );
 
-        var io = ie = 0, res = [],
-            escapeEl = document.createElement('textarea'),
-            escapeHTML = function(html) {
-              escapeEl.textContent = html;
-              return escapeEl.innerHTML;
-            };
+        var io = 0,
+          ie = 0,
+          res = [],
+          escapeEl = document.createElement('textarea'),
+          escapeHTML = function(html) {
+            escapeEl.textContent = html;
+            return escapeEl.innerHTML;
+          };
 
         while (io < out.length && ie < err.length) {
           if (pgAdmin.natural_sort(out[io][0], err[ie][0]) <= 0){
@@ -452,7 +454,7 @@ define([
             if (!res || !_.isArray(res)) {
               return;
             }
-            for (idx in res) {
+            for (var idx in res) {
               var process = res[idx];
               if ('id' in process) {
                 if (!(process.id in observer.bgprocesses)) {
diff --git a/web/pgadmin/misc/depends/static/js/depends.js b/web/pgadmin/misc/depends/static/js/depends.js
index b4319f11..2ba50c88 100644
--- a/web/pgadmin/misc/depends/static/js/depends.js
+++ b/web/pgadmin/misc/depends/static/js/depends.js
@@ -1,4 +1,4 @@
-define([
+define('misc.depends', [
   'sources/gettext', 'underscore', 'underscore.string', 'jquery', 'pgadmin.browser',
   'alertify', 'pgadmin.alertifyjs'
 ], function(gettext, _, S, $, pgBrowser, Alertify) {
@@ -6,6 +6,8 @@ define([
   if (pgBrowser.ShowNodeDepends)
     return pgBrowser.ShowNodeDepends;
 
+  var wcDocker = window.wcDocker;
+
   pgBrowser.ShowNodeDepends = pgBrowser.ShowNodeDepends || {};
 
   _.extend(pgBrowser.ShowNodeDepends, {
@@ -192,7 +194,7 @@ define([
       var msg = messages[0],
           $container = panel[0].layout().scene().find('.pg-panel-content'),
           $msgContainer = $container.find('.pg-panel-depends-message'),
-          $gridContainer = $container.find('.pg-panel-depends-container');
+          $gridContainer = $container.find('.pg-panel-depends-container'),
           treeHierarchy = node.getTreeNodeHierarchy(item),
           n_value = -1,
           n_type = type;
diff --git a/web/pgadmin/misc/file_manager/__init__.py b/web/pgadmin/misc/file_manager/__init__.py
index 0e39fa95..5a7f2015 100644
--- a/web/pgadmin/misc/file_manager/__init__.py
+++ b/web/pgadmin/misc/file_manager/__init__.py
@@ -144,6 +144,19 @@ class FileManagerModule(PgAdminModule):
             'file_items': []
         }
 
+    def get_exposed_url_endpoints(self):
+        """
+        Returns:
+            list: a list of url endpoints exposed to the client.
+        """
+        return [
+            'file_manager.filemanager',
+            'file_manager.index',
+            'file_manager.get_trans_id',
+            'file_manager.delete_trans_id',
+            'file_manager.save_last_dir'
+        ]
+
     def get_file_size_preference(self):
         return self.file_upload_size
 
@@ -165,7 +178,7 @@ class FileManagerModule(PgAdminModule):
 blueprint = FileManagerModule(MODULE_NAME, __name__)
 
 
-@blueprint.route("/")
+@blueprint.route("/", endpoint='index')
 @login_required
 def index():
     """Render the preferences dialog."""
@@ -226,7 +239,9 @@ def file_manager_config(trans_id):
         mimetype="application/json")
 
 
-@blueprint.route("/get_trans_id", methods=["GET", "POST"])
+@blueprint.route(
+    "/get_trans_id", methods=["GET", "POST"], endpoint='get_trans_id'
+)
 @login_required
 def get_trans_id():
     if len(req.data) != 0:
@@ -239,7 +254,10 @@ def get_trans_id():
     )
 
 
-@blueprint.route("/del_trans_id/<int:trans_id>", methods=["GET", "POST"])
+@blueprint.route(
+    "/del_trans_id/<int:trans_id>",
+    methods=["GET", "POST"], endpoint='delete_trans_id'
+)
 @login_required
 def delete_trans_id(trans_id):
     Filemanager.release_transaction(trans_id)
@@ -248,7 +266,9 @@ def delete_trans_id(trans_id):
     )
 
 
-@blueprint.route("/save_last_dir/<int:trans_id>", methods=["POST"])
+@blueprint.route(
+    "/save_last_dir/<int:trans_id>", methods=["POST"], endpoint='save_last_dir'
+)
 @login_required
 def save_last_directory_visited(trans_id):
     blueprint.last_directory_visited.set(req.json['path'])
@@ -1122,7 +1142,10 @@ class Filemanager(object):
         return res
 
 
-@blueprint.route("/filemanager/<int:trans_id>/", methods=["GET", "POST"])
+@blueprint.route(
+    "/filemanager/<int:trans_id>/",
+    methods=["GET", "POST"], endpoint='filemanager'
+)
 @login_required
 def file_manager(trans_id):
     """
